/*___INFO__MARK_BEGIN__*/
/*************************************************************************
 *
 *  The Contents of this file are made available subject to the terms of
 *  the Sun Industry Standards Source License Version 1.2
 *
 *  Sun Microsystems Inc., March, 2001
 *
 *
 *  Sun Industry Standards Source License Version 1.2
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.2 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://gridengine.sunsource.net/Gridengine_SISSL_license.html
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *   The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *   Copyright: 2001 by Sun Microsystems, Inc.
 *
 *   All Rights Reserved.
 *
 ************************************************************************/
/*___INFO__MARK_END__*/

/*  Generated from c_event_client.jsp
 *  !!! DO NOT EDIT THIS FILE !!!
 */

#include <ctype.h>
#include <string.h>
#include <jni.h>
#include "jgdi.h"
#include "basis_types.h"
#include "cull.h"
#include "commlib.h"
#include "sgermon.h"
#include "sge_all_listsL.h"
#include "sge_answer.h"
#include "sge_prog.h"
#include "sge_bootstrap.h"
#include "sge_gdi_ctx.h"
#include "cl_errors.h"
#include "sge_log.h"
#include "sge_error_class.h"
#include "jgdi_common.h"
#include "sge_event_client.h"
#include "jgdi_event.h"
#include "sge_mirror.h"
#include "sge_event.h"
#include "jgdi_wrapper.h"



jgdi_result_t process_generic_event(JNIEnv *env,  jobject *event, lListElem *ev, lList** alpp) {

   switch( lGetUlong(ev, ET_type)) {

      case sgeE_HGROUP_MOD:
         return create_generic_event(env, event,"com/sun/grid/jgdi/configuration/Hostgroup", "HGRP_Type", HGRP_Type, SGE_EMA_MOD, ev, alpp);
      
      case sgeE_HGROUP_LIST:
         return create_generic_event(env, event,"com/sun/grid/jgdi/configuration/Hostgroup", "HGRP_Type", HGRP_Type, SGE_EMA_LIST, ev, alpp);
      
      case sgeE_HGROUP_DEL:
         return create_generic_event(env, event,"com/sun/grid/jgdi/configuration/Hostgroup", "HGRP_Type", HGRP_Type, SGE_EMA_DEL, ev, alpp);
      
      case sgeE_HGROUP_ADD:
         return create_generic_event(env, event,"com/sun/grid/jgdi/configuration/Hostgroup", "HGRP_Type", HGRP_Type, SGE_EMA_ADD, ev, alpp);

      case sgeE_SUBMITHOST_MOD:
         return create_generic_event(env, event,"com/sun/grid/jgdi/configuration/SubmitHost", "SH_Type", SH_Type, SGE_EMA_MOD, ev, alpp);
      
      case sgeE_SUBMITHOST_LIST:
         return create_generic_event(env, event,"com/sun/grid/jgdi/configuration/SubmitHost", "SH_Type", SH_Type, SGE_EMA_LIST, ev, alpp);
      
      case sgeE_SUBMITHOST_DEL:
         return create_generic_event(env, event,"com/sun/grid/jgdi/configuration/SubmitHost", "SH_Type", SH_Type, SGE_EMA_DEL, ev, alpp);
      
      case sgeE_SUBMITHOST_ADD:
         return create_generic_event(env, event,"com/sun/grid/jgdi/configuration/SubmitHost", "SH_Type", SH_Type, SGE_EMA_ADD, ev, alpp);

      case sgeE_EXECHOST_MOD:
         return create_generic_event(env, event,"com/sun/grid/jgdi/configuration/ExecHost", "EH_Type", EH_Type, SGE_EMA_MOD, ev, alpp);
      
      case sgeE_EXECHOST_LIST:
         return create_generic_event(env, event,"com/sun/grid/jgdi/configuration/ExecHost", "EH_Type", EH_Type, SGE_EMA_LIST, ev, alpp);
      
      case sgeE_EXECHOST_DEL:
         return create_generic_event(env, event,"com/sun/grid/jgdi/configuration/ExecHost", "EH_Type", EH_Type, SGE_EMA_DEL, ev, alpp);
      
      case sgeE_EXECHOST_ADD:
         return create_generic_event(env, event,"com/sun/grid/jgdi/configuration/ExecHost", "EH_Type", EH_Type, SGE_EMA_ADD, ev, alpp);

      case sgeE_MANAGER_MOD:
         return create_generic_event(env, event,"com/sun/grid/jgdi/configuration/Manager", "UM_Type", UM_Type, SGE_EMA_MOD, ev, alpp);
      
      case sgeE_MANAGER_LIST:
         return create_generic_event(env, event,"com/sun/grid/jgdi/configuration/Manager", "UM_Type", UM_Type, SGE_EMA_LIST, ev, alpp);
      
      case sgeE_MANAGER_DEL:
         return create_generic_event(env, event,"com/sun/grid/jgdi/configuration/Manager", "UM_Type", UM_Type, SGE_EMA_DEL, ev, alpp);
      
      case sgeE_MANAGER_ADD:
         return create_generic_event(env, event,"com/sun/grid/jgdi/configuration/Manager", "UM_Type", UM_Type, SGE_EMA_ADD, ev, alpp);

      case sgeE_AR_MOD:
         return create_generic_event(env, event,"com/sun/grid/jgdi/configuration/AdvanceReservation", "AR_Type", AR_Type, SGE_EMA_MOD, ev, alpp);
      
      case sgeE_AR_LIST:
         return create_generic_event(env, event,"com/sun/grid/jgdi/configuration/AdvanceReservation", "AR_Type", AR_Type, SGE_EMA_LIST, ev, alpp);
      
      case sgeE_AR_DEL:
         return create_generic_event(env, event,"com/sun/grid/jgdi/configuration/AdvanceReservation", "AR_Type", AR_Type, SGE_EMA_DEL, ev, alpp);
      
      case sgeE_AR_ADD:
         return create_generic_event(env, event,"com/sun/grid/jgdi/configuration/AdvanceReservation", "AR_Type", AR_Type, SGE_EMA_ADD, ev, alpp);
      
      case sgeE_PETASK_DEL:
         return create_generic_event(env, event,"com/sun/grid/jgdi/configuration/PETask", "PET_Type", PET_Type, SGE_EMA_DEL, ev, alpp);
      
      case sgeE_PETASK_ADD:
         return create_generic_event(env, event,"com/sun/grid/jgdi/configuration/PETask", "PET_Type", PET_Type, SGE_EMA_ADD, ev, alpp);

      case sgeE_SCHED_CONF:
         return create_generic_event(env, event,"com/sun/grid/jgdi/configuration/SchedConf", "SC_Type", SC_Type, SGE_EMA_MOD, ev, alpp);

      case sgeE_CONFIG_MOD:
         return create_generic_event(env, event,"com/sun/grid/jgdi/configuration/Configuration", "CONF_Type", CONF_Type, SGE_EMA_MOD, ev, alpp);
      
      case sgeE_CONFIG_LIST:
         return create_generic_event(env, event,"com/sun/grid/jgdi/configuration/Configuration", "CONF_Type", CONF_Type, SGE_EMA_LIST, ev, alpp);
      
      case sgeE_CONFIG_DEL:
         return create_generic_event(env, event,"com/sun/grid/jgdi/configuration/Configuration", "CONF_Type", CONF_Type, SGE_EMA_DEL, ev, alpp);
      
      case sgeE_CONFIG_ADD:
         return create_generic_event(env, event,"com/sun/grid/jgdi/configuration/Configuration", "CONF_Type", CONF_Type, SGE_EMA_ADD, ev, alpp);

      case sgeE_PROJECT_MOD:
         return create_generic_event(env, event,"com/sun/grid/jgdi/configuration/Project", "PR_Type", PR_Type, SGE_EMA_MOD, ev, alpp);
      
      case sgeE_PROJECT_LIST:
         return create_generic_event(env, event,"com/sun/grid/jgdi/configuration/Project", "PR_Type", PR_Type, SGE_EMA_LIST, ev, alpp);
      
      case sgeE_PROJECT_DEL:
         return create_generic_event(env, event,"com/sun/grid/jgdi/configuration/Project", "PR_Type", PR_Type, SGE_EMA_DEL, ev, alpp);
      
      case sgeE_PROJECT_ADD:
         return create_generic_event(env, event,"com/sun/grid/jgdi/configuration/Project", "PR_Type", PR_Type, SGE_EMA_ADD, ev, alpp);

      case sgeE_NEW_SHARETREE:
         return create_generic_event(env, event,"com/sun/grid/jgdi/configuration/ShareTree", "STN_Type", STN_Type, SGE_EMA_MOD, ev, alpp);

      case sgeE_ADMINHOST_MOD:
         return create_generic_event(env, event,"com/sun/grid/jgdi/configuration/AdminHost", "AH_Type", AH_Type, SGE_EMA_MOD, ev, alpp);
      
      case sgeE_ADMINHOST_LIST:
         return create_generic_event(env, event,"com/sun/grid/jgdi/configuration/AdminHost", "AH_Type", AH_Type, SGE_EMA_LIST, ev, alpp);
      
      case sgeE_ADMINHOST_DEL:
         return create_generic_event(env, event,"com/sun/grid/jgdi/configuration/AdminHost", "AH_Type", AH_Type, SGE_EMA_DEL, ev, alpp);
      
      case sgeE_ADMINHOST_ADD:
         return create_generic_event(env, event,"com/sun/grid/jgdi/configuration/AdminHost", "AH_Type", AH_Type, SGE_EMA_ADD, ev, alpp);

      case sgeE_CKPT_MOD:
         return create_generic_event(env, event,"com/sun/grid/jgdi/configuration/Checkpoint", "CK_Type", CK_Type, SGE_EMA_MOD, ev, alpp);
      
      case sgeE_CKPT_LIST:
         return create_generic_event(env, event,"com/sun/grid/jgdi/configuration/Checkpoint", "CK_Type", CK_Type, SGE_EMA_LIST, ev, alpp);
      
      case sgeE_CKPT_DEL:
         return create_generic_event(env, event,"com/sun/grid/jgdi/configuration/Checkpoint", "CK_Type", CK_Type, SGE_EMA_DEL, ev, alpp);
      
      case sgeE_CKPT_ADD:
         return create_generic_event(env, event,"com/sun/grid/jgdi/configuration/Checkpoint", "CK_Type", CK_Type, SGE_EMA_ADD, ev, alpp);

      case sgeE_PE_MOD:
         return create_generic_event(env, event,"com/sun/grid/jgdi/configuration/ParallelEnvironment", "PE_Type", PE_Type, SGE_EMA_MOD, ev, alpp);
      
      case sgeE_PE_LIST:
         return create_generic_event(env, event,"com/sun/grid/jgdi/configuration/ParallelEnvironment", "PE_Type", PE_Type, SGE_EMA_LIST, ev, alpp);
      
      case sgeE_PE_DEL:
         return create_generic_event(env, event,"com/sun/grid/jgdi/configuration/ParallelEnvironment", "PE_Type", PE_Type, SGE_EMA_DEL, ev, alpp);
      
      case sgeE_PE_ADD:
         return create_generic_event(env, event,"com/sun/grid/jgdi/configuration/ParallelEnvironment", "PE_Type", PE_Type, SGE_EMA_ADD, ev, alpp);

      case sgeE_JATASK_MOD:
         return create_generic_event(env, event,"com/sun/grid/jgdi/configuration/JobTask", "JAT_Type", JAT_Type, SGE_EMA_MOD, ev, alpp);
      
      case sgeE_JATASK_DEL:
         return create_generic_event(env, event,"com/sun/grid/jgdi/configuration/JobTask", "JAT_Type", JAT_Type, SGE_EMA_DEL, ev, alpp);
      
      case sgeE_JATASK_ADD:
         return create_generic_event(env, event,"com/sun/grid/jgdi/configuration/JobTask", "JAT_Type", JAT_Type, SGE_EMA_ADD, ev, alpp);

      case sgeE_CENTRY_MOD:
         return create_generic_event(env, event,"com/sun/grid/jgdi/configuration/ComplexEntry", "CE_Type", CE_Type, SGE_EMA_MOD, ev, alpp);
      
      case sgeE_CENTRY_LIST:
         return create_generic_event(env, event,"com/sun/grid/jgdi/configuration/ComplexEntry", "CE_Type", CE_Type, SGE_EMA_LIST, ev, alpp);
      
      case sgeE_CENTRY_DEL:
         return create_generic_event(env, event,"com/sun/grid/jgdi/configuration/ComplexEntry", "CE_Type", CE_Type, SGE_EMA_DEL, ev, alpp);
      
      case sgeE_CENTRY_ADD:
         return create_generic_event(env, event,"com/sun/grid/jgdi/configuration/ComplexEntry", "CE_Type", CE_Type, SGE_EMA_ADD, ev, alpp);

      case sgeE_CQUEUE_MOD:
         return create_generic_event(env, event,"com/sun/grid/jgdi/configuration/ClusterQueue", "CQ_Type", CQ_Type, SGE_EMA_MOD, ev, alpp);
      
      case sgeE_CQUEUE_LIST:
         return create_generic_event(env, event,"com/sun/grid/jgdi/configuration/ClusterQueue", "CQ_Type", CQ_Type, SGE_EMA_LIST, ev, alpp);
      
      case sgeE_CQUEUE_DEL:
         return create_generic_event(env, event,"com/sun/grid/jgdi/configuration/ClusterQueue", "CQ_Type", CQ_Type, SGE_EMA_DEL, ev, alpp);
      
      case sgeE_CQUEUE_ADD:
         return create_generic_event(env, event,"com/sun/grid/jgdi/configuration/ClusterQueue", "CQ_Type", CQ_Type, SGE_EMA_ADD, ev, alpp);

      case sgeE_JOB_SCHEDD_INFO_MOD:
         return create_generic_event(env, event,"com/sun/grid/jgdi/configuration/JobSchedulingInfo", "SME_Type", SME_Type, SGE_EMA_MOD, ev, alpp);
      
      case sgeE_JOB_SCHEDD_INFO_LIST:
         return create_generic_event(env, event,"com/sun/grid/jgdi/configuration/JobSchedulingInfo", "SME_Type", SME_Type, SGE_EMA_LIST, ev, alpp);
      
      case sgeE_JOB_SCHEDD_INFO_DEL:
         return create_generic_event(env, event,"com/sun/grid/jgdi/configuration/JobSchedulingInfo", "SME_Type", SME_Type, SGE_EMA_DEL, ev, alpp);
      
      case sgeE_JOB_SCHEDD_INFO_ADD:
         return create_generic_event(env, event,"com/sun/grid/jgdi/configuration/JobSchedulingInfo", "SME_Type", SME_Type, SGE_EMA_ADD, ev, alpp);

      case sgeE_USERSET_MOD:
         return create_generic_event(env, event,"com/sun/grid/jgdi/configuration/UserSet", "US_Type", US_Type, SGE_EMA_MOD, ev, alpp);
      
      case sgeE_USERSET_LIST:
         return create_generic_event(env, event,"com/sun/grid/jgdi/configuration/UserSet", "US_Type", US_Type, SGE_EMA_LIST, ev, alpp);
      
      case sgeE_USERSET_DEL:
         return create_generic_event(env, event,"com/sun/grid/jgdi/configuration/UserSet", "US_Type", US_Type, SGE_EMA_DEL, ev, alpp);
      
      case sgeE_USERSET_ADD:
         return create_generic_event(env, event,"com/sun/grid/jgdi/configuration/UserSet", "US_Type", US_Type, SGE_EMA_ADD, ev, alpp);

      case sgeE_CALENDAR_MOD:
         return create_generic_event(env, event,"com/sun/grid/jgdi/configuration/Calendar", "CAL_Type", CAL_Type, SGE_EMA_MOD, ev, alpp);
      
      case sgeE_CALENDAR_LIST:
         return create_generic_event(env, event,"com/sun/grid/jgdi/configuration/Calendar", "CAL_Type", CAL_Type, SGE_EMA_LIST, ev, alpp);
      
      case sgeE_CALENDAR_DEL:
         return create_generic_event(env, event,"com/sun/grid/jgdi/configuration/Calendar", "CAL_Type", CAL_Type, SGE_EMA_DEL, ev, alpp);
      
      case sgeE_CALENDAR_ADD:
         return create_generic_event(env, event,"com/sun/grid/jgdi/configuration/Calendar", "CAL_Type", CAL_Type, SGE_EMA_ADD, ev, alpp);

      case sgeE_OPERATOR_MOD:
         return create_generic_event(env, event,"com/sun/grid/jgdi/configuration/Operator", "UO_Type", UO_Type, SGE_EMA_MOD, ev, alpp);
      
      case sgeE_OPERATOR_LIST:
         return create_generic_event(env, event,"com/sun/grid/jgdi/configuration/Operator", "UO_Type", UO_Type, SGE_EMA_LIST, ev, alpp);
      
      case sgeE_OPERATOR_DEL:
         return create_generic_event(env, event,"com/sun/grid/jgdi/configuration/Operator", "UO_Type", UO_Type, SGE_EMA_DEL, ev, alpp);
      
      case sgeE_OPERATOR_ADD:
         return create_generic_event(env, event,"com/sun/grid/jgdi/configuration/Operator", "UO_Type", UO_Type, SGE_EMA_ADD, ev, alpp);

      case sgeE_JOB_MOD:
         return create_generic_event(env, event,"com/sun/grid/jgdi/configuration/Job", "JB_Type", JB_Type, SGE_EMA_MOD, ev, alpp);
      
      case sgeE_JOB_LIST:
         return create_generic_event(env, event,"com/sun/grid/jgdi/configuration/Job", "JB_Type", JB_Type, SGE_EMA_LIST, ev, alpp);
      
      case sgeE_JOB_DEL:
         return create_generic_event(env, event,"com/sun/grid/jgdi/configuration/Job", "JB_Type", JB_Type, SGE_EMA_DEL, ev, alpp);
      
      case sgeE_JOB_ADD:
         return create_generic_event(env, event,"com/sun/grid/jgdi/configuration/Job", "JB_Type", JB_Type, SGE_EMA_ADD, ev, alpp);

      case sgeE_QINSTANCE_MOD:
         return create_generic_event(env, event,"com/sun/grid/jgdi/configuration/QueueInstance", "QU_Type", QU_Type, SGE_EMA_MOD, ev, alpp);
      
      case sgeE_QINSTANCE_DEL:
         return create_generic_event(env, event,"com/sun/grid/jgdi/configuration/QueueInstance", "QU_Type", QU_Type, SGE_EMA_DEL, ev, alpp);
      
      case sgeE_QINSTANCE_ADD:
         return create_generic_event(env, event,"com/sun/grid/jgdi/configuration/QueueInstance", "QU_Type", QU_Type, SGE_EMA_ADD, ev, alpp);

      case sgeE_RQS_MOD:
         return create_generic_event(env, event,"com/sun/grid/jgdi/configuration/ResourceQuotaSet", "RQS_Type", RQS_Type, SGE_EMA_MOD, ev, alpp);
      
      case sgeE_RQS_LIST:
         return create_generic_event(env, event,"com/sun/grid/jgdi/configuration/ResourceQuotaSet", "RQS_Type", RQS_Type, SGE_EMA_LIST, ev, alpp);
      
      case sgeE_RQS_DEL:
         return create_generic_event(env, event,"com/sun/grid/jgdi/configuration/ResourceQuotaSet", "RQS_Type", RQS_Type, SGE_EMA_DEL, ev, alpp);
      
      case sgeE_RQS_ADD:
         return create_generic_event(env, event,"com/sun/grid/jgdi/configuration/ResourceQuotaSet", "RQS_Type", RQS_Type, SGE_EMA_ADD, ev, alpp);

      case sgeE_USER_MOD:
         return create_generic_event(env, event,"com/sun/grid/jgdi/configuration/User", "UU_Type", UU_Type, SGE_EMA_MOD, ev, alpp);
      
      case sgeE_USER_LIST:
         return create_generic_event(env, event,"com/sun/grid/jgdi/configuration/User", "UU_Type", UU_Type, SGE_EMA_LIST, ev, alpp);
      
      case sgeE_USER_DEL:
         return create_generic_event(env, event,"com/sun/grid/jgdi/configuration/User", "UU_Type", UU_Type, SGE_EMA_DEL, ev, alpp);
      
      case sgeE_USER_ADD:
         return create_generic_event(env, event,"com/sun/grid/jgdi/configuration/User", "UU_Type", UU_Type, SGE_EMA_ADD, ev, alpp);
  
      default:
         answer_list_add_sprintf(alpp, STATUS_EUNKNOWN, ANSWER_QUALITY_ERROR, 
                                 "Event action not yet handled %d",  lGetUlong(ev, ET_type));
         return JGDI_ERROR;
   }

}
